
hirom  ; don't change this
header

org $C25E0B  ; location in v1.0 and v1.1
;org $C25DF3  ; location in SFC version
JSR somewhere

org $C2A736
somewhere:
JSR $5FD4  ; do the experience message first
; note that coming in we've already determined if XP per character is 0 for the main party
; what we must do is determine how many characters are inactive, then divide the remaining experience
TDC  ; let's do some prep work first
TAX
DEC A
init_loop:
STA $1410,X  ; let's #$FF a small chunk
INX
CPX #$000E
BNE init_loop 
; now that initial prep work is done, let's move on to the real deal
TDC  ; empty A
TAX  ; empty X
TXY  ; and empty Y
PHA  ; start at 0 characters
loopy:
SEP #$20
LDA $3000,Y  ; load characters in active party
REP #$20
BPL loopy_loop  ; branch if they are in this active party!
PLA  ; grab characters
INC A  ; this one is active
PHA  ; save again
AND $1EDE  ; have we recruited this character?
BEQ loopy_loop  ; branch if not
INX  ; # of party members inactive
SEP #$20
TYA
STA $1410,Y  ; it'll be FF or the character ID
REP #$20
loopy_loop:
PLA
ASL A
PHA
INY
CPY #$000E  ; have we checked all characters yet?
BNE loopy  ; branch if not
PLA  ; we don't need A anymore
CPX $00  ; are there no inactive members?
BEQ done  ; branch if so, don't bother trying to give what nobody can collect
; now to divide up the remaining experience
LDA $2F35  ; grab lower and middle bytes of divided experience
STA $E8  ; save it for now
LDA $2F36  ; grab middle and high bytes of divided experience
PHX  ; save # of party members for now
JSR $4792  ; divides 16-bit A by 8-bit X, meaning divide the leftover experience (higher 2 bytes) by our leftover party members
STA $EC  ; save quotient
STX $E9  ; save remainder
LDA $E8
PLX  ; get # of party members again
JSR $4792  ; divides 16-bit A by 8-bit X, meaning divide the leftover experience (lower 2 bytes) by our leftover party members
STA $2F35  ; this is the experience the other party members will get
LDA $EC  ; load previous quotient for the upper 2 bytes
STA $2F36  ; save it
ORA $2F35  ; and ORA just to determine if there's any experience at all
BEQ done  ; branch if there's no experience left
; now we need to actually give the experience to each character
LDY $00
loopy_exp:
SEP #$20
TDC
LDA $1410,Y
INC A  ; is there a character ID here?
BEQ no_exp  ; branch if not
DEC A
PHA  ; save ID
JSR $6283  ; get address of character's magic list (just in case!) and put it in $F4
TDC
PLA  ; get ID
ASL A
REP #$20
TAX
LDA $C36969,X  ; load character position in ram
SEC
SBC #$1600
TAX
LDA $1614,X  ; status byte 1
BIT #$00C2  ; check for death, petrified, and zombie
BNE no_exp  ; branch if any set, since they can't gain when they're dead
JSR $6235  ; add experience for this character
SEP #$20
JSR $606D  ; level up this character, if possible
LDA $1410,Y
CMP #$0C
BCS no_exp
JSR learn_magic  ; learn magic that was set to >= #$80, the only difference is the message won't be displayed. it is exactly the same as C2/6133 otherwise
no_exp:
INY
CPY #$000E  ; have we done all 14 characters yet?
BNE loopy_exp
done:
RTS

learn_magic:
PHY
LDY #$0035
magic_loop:
LDA ($F4),Y
CMP #$80
BNE next_spell
LDA #$FF
STA ($F4),Y
next_spell:
DEY
BPL magic_loop
PLY
RTS
